﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using Sample.Models;
using Syncfusion.OfficeChart;
using Syncfusion.Presentation;
using Syncfusion.PresentationToPdfConverter; 
using Syncfusion.Pdf;
using System.Threading;

namespace Sample.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        private readonly IHostingEnvironment _hostingEnvironment;

        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }

        [HttpPost]

        public IActionResult ConvertToPDF()
        {
            //Load the PowerPoint presentation into stream.
            FileStream fileStreamInput = new FileStream(_hostingEnvironment.WebRootPath + @"\Template.pptx", FileMode.Open, FileAccess.Read);
            //Open the existing PowerPoint presentation with loaded stream.
            IPresentation pptxDoc = Presentation.Open(fileStreamInput);
            //Create the MemoryStream to save the converted PDF.
            MemoryStream pdfStream = new MemoryStream();
            //Convert the PowerPoint document to PDF document.
            PdfDocument pdfDocument = PresentationToPdfConverter.Convert(pptxDoc);
            //Save the converted PDF document to MemoryStream.
            pdfDocument.Save(pdfStream);
            pdfStream.Position = 0;
            //Create the output PDF file stream
            FileStreamResult fileStreamOutput = new FileStreamResult(pdfStream, "application/pdf");
            fileStreamOutput.FileDownloadName = "Output.pdf";
            return fileStreamOutput;
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}
